﻿using System;
using Ryuclaw.Shared.Audio;
using OpenAL;
using System.Numerics;

namespace Ryuclaw.Audio.Desktop;

public class AudioEngine : IAudioEngine
{
    private readonly object _lock = new object();
    private IntPtr _context;
    private IntPtr _device;
    private AudioCache _cache;

    public AudioEngine()
    {
        _device = ALC10.alcOpenDevice(null);
        _context = ALC10.alcCreateContext(_device, null);

        _cache = new AudioCache();
    }

    public IAudioSource CreateSource(string name)
    {
        throw new NotImplementedException();
    }

    public void SetListenerOrientation(Vector3 forward, Vector3 up)
    {
        throw new NotImplementedException();
    }

    public void SetListenerPosition(Vector3 position)
    {
        throw new NotImplementedException();
    }

    public bool Start()
    {
        ALC10.alcMakeContextCurrent(_context);
        return true;
    }

    public void Stop()
    {
        throw new NotImplementedException();
    }

    public void Update(float dt)
    {
        throw new NotImplementedException();
    }
}

