﻿using ObjCRuntime;
using Ryuclaw.Speech.MacOS;
using Ryuclaw.Audio.Desktop;

namespace Ryuclaw.Client.Mac;

public partial class ViewController : NSViewController {
	private TTS synth = new TTS();
	private AudioEngine engine = new AudioEngine();

	protected ViewController (NativeHandle handle) : base (handle)
	{
		// This constructor is required if the view controller is loaded from a xib or a storyboard.
		// Do not put any initialization here, use ViewDidLoad instead.
	}

	public override void ViewDidLoad ()
	{
		base.ViewDidLoad ();

		// Do any additional setup after loading the view.
		synth.SetVoice("Alex");
		synth.Speak("Rawr, rawr!");

		engine.Start();
	}

	public override NSObject RepresentedObject {
		get => base.RepresentedObject;
		set {
			base.RepresentedObject = value;

			// Update the view, if already loaded.
		}
	}
}

