﻿using System;
using System.Numerics;

namespace Ryuclaw.Shared.Audio
{
	public interface IAudioEngine
	{
		public bool Start();
		public void Stop();
		public void Update(float dt);
		public void SetListenerPosition(Vector3 position);
		public void SetListenerOrientation(Vector3 forward, Vector3 up);
		public IAudioSource CreateSource(string name);
	}
}

