﻿using System;
using System.Numerics;

namespace Ryuclaw.Shared.Audio
{
	public interface IAudioSource
	{
		public void Play();
		public void Stop();
		public void Update(float dt);
		public void SetPosition(Vector3 position);
	}
}

